package com.jiuqi.util;

package .tmp;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

public class EncryptUtil {
  public static char ENCRYPT_KEY = '\t';
  
  public static boolean encryptFile(String inFile, String outFile) {
    return encryptFile(new File(inFile), new File(outFile));
  }
  
  public static boolean encryptFile(DataInputStream in, DataOutputStream out) {
    boolean result = false;
    char key = ENCRYPT_KEY;
    try {
      try {
        while (true) {
          byte b = in.readByte();
          byte k = (byte)(key >>> 8);
          b = (byte)(b ^ k);
          key = (char)(key + (b & 0xFF));
          out.writeByte(b);
        } 
      } catch (EOFException eOFException) {
        result = true;
      } 
    } catch (Exception e) {
      e.printStackTrace();
      result = false;
    } finally {
      try {
        in.close();
        out.close();
      } catch (Exception exception) {}
    } 
  }
  
  public static boolean encryptFile(File inFile, File outFile) {
    DataInputStream in = null;
    DataOutputStream out = null;
    boolean result = false;
    char key = ENCRYPT_KEY;
    if (!outFile.exists())
      try {
        outFile.createNewFile();
      } catch (IOException e) {
        e.printStackTrace();
        return false;
      }  
    if (!inFile.exists()) {
      System.out.println("加密操作失败:待加密文件不存在。");
      return false;
    } 
    try {
      in = new DataInputStream(new BufferedInputStream(new FileInputStream(inFile)));
      out = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(outFile)));
      try {
        while (true) {
          byte b = in.readByte();
          byte k = (byte)(key >>> 8);
          b = (byte)(b ^ k);
          key = (char)(key + (b & 0xFF));
          out.writeByte(b);
        } 
      } catch (EOFException eOFException) {
        result = true;
      } 
    } catch (Exception e) {
      e.printStackTrace();
      result = false;
    } finally {
      try {
        if (in != null)
          in.close(); 
        if (out != null)
          out.close(); 
      } catch (Exception e) {
        e.printStackTrace();
      } 
    } 
  }
  
  public static boolean decryptFile(String inFile, String outFile) {
    return decryptFile(new File(inFile), new File(outFile));
  }
  
  public static boolean decryptFile(File inFile, File outFile) {
    boolean result = false;
    char key = ENCRYPT_KEY;
    DataInputStream in = null;
    DataOutputStream out = null;
    if (!outFile.exists())
      try {
        outFile.createNewFile();
      } catch (IOException e) {
        e.printStackTrace();
        return false;
      }  
    if (!inFile.exists()) {
      System.out.println("解密操作失败:待解密文件不存在。");
      return false;
    } 
    try {
      in = new DataInputStream(new BufferedInputStream(new FileInputStream(inFile)));
      out = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(outFile)));
      try {
        while (true) {
          byte temp = in.readByte();
          byte b = temp;
          byte tk = (byte)(key >>> 8);
          temp = (byte)(temp ^ tk);
          key = (char)(key + (b & 0xFF));
          out.writeByte(temp);
        } 
      } catch (EOFException eOFException) {
        result = true;
      } 
    } catch (Exception e) {
      e.printStackTrace();
      result = false;
    } finally {
      try {
        if (in != null)
          in.close(); 
        if (out != null)
          out.close(); 
      } catch (Exception e) {
        e.printStackTrace();
      } 
    } 
  }
  
  public static boolean decryptFile(DataInputStream in, DataOutputStream out) {
    boolean result = false;
    char key = ENCRYPT_KEY;
    try {
      try {
        while (true) {
          byte temp = in.readByte();
          byte b = temp;
          byte tk = (byte)(key >>> 8);
          temp = (byte)(temp ^ tk);
          key = (char)(key + (b & 0xFF));
          out.writeByte(temp);
        } 
      } catch (EOFException eOFException) {
        result = true;
      } 
    } catch (Exception e) {
      e.printStackTrace();
      result = false;
    } finally {
      try {
        in.close();
        out.close();
      } catch (Exception exception) {}
    } 
  }
}
